<template>
  <ai-list class="notice">
    <template slot="title">
      <ai-title title="村规民约" isShowBottomBorder isShowArea v-model="search.areaId" :instance="instance" @change="search.current = 1, getList()"></ai-title>
    </template>
    <template slot="content">
      <ai-search-bar class="search-bar">
        <template #left>
          <el-button size="small" type="primary" icon="iconfont iconAdd" @click="toAdd('')">添加</el-button>
        </template>
        <template #right>
          <el-input
            v-model="search.title"
            class="search-input"
            size="small"
            @keyup.enter.native="search.current = 1, search.title, getList()"
            placeholder="请输入标题"
            clearable
            @clear="search.current = 1, search.title = '', getList()"
            suffix-icon="iconfont iconSearch">
          </el-input>
        </template>
      </ai-search-bar>
      <ai-table
        :tableData="tableData"
        :col-configs="colConfigs"
        :total="total"
        style="margin-top: 6px;"
        :current.sync="search.current"
        :size.sync="search.size"
        @getList="getList">
        <el-table-column slot="tags" label="标签">
          <template slot-scope="{ row }">
            <div class="table-tags">
              <el-tag type="info" v-for="(item, index) in row.tags" size="small" :key="index">{{ item }}</el-tag>
            </div>
          </template>
        </el-table-column>
        <el-table-column slot="options" width="220px" fixed="right" label="操作" align="center">
          <template slot-scope="{ row }">
            <div class="table-options">
              <el-button type="text" :title="row.status == 1 ? '取消发布' : '发布'" @click="changeStatus(row)">{{ row.status == 1 ? '取消发布' : '发布' }}</el-button>
              <el-button type="text" @click="toAdd(row.id)">编辑</el-button>
              <el-button type="text" @click="remove(row.id)">删除</el-button>
            </div>
          </template>
        </el-table-column>
      </ai-table>
    </template>
  </ai-list>
</template>

<script>
  import { mapState } from 'vuex'
  export default {
    name: 'List',

    props: {
      instance: Function,
      dict: Object
    },

    data() {
      return {
        search: {
          current: 1,
          size: 10,
          title: '',
          areaId: ''
        },
        currIndex: -1,
        areaList: [],
        total: 10,
        colConfigs: [
          { prop: 'title',  label: '标题', align: 'left', width: '200px' },
          { prop: 'areaName', label: '地区', align: 'center' },
          { prop: 'status', label: '发布状态', align: 'center', formart: v => v === '1' ? '已发布' : '未发布' },
          { prop: 'createUserName', label: '发布人', align: 'center' },
          { prop: 'createDate', label: '发布时间', align: 'center' },
          { slot: 'options', label: '操作', align: 'center' }
        ],
        areaName: '',
        unitName: '',
        tableData: []
      }
    },

    computed: {
      ...mapState(['user'])
    },

    mounted() {
      this.search.areaId = this.user.info.areaId
      this.getList()
    },

    methods: {
      getList() {
        this.instance.post(`/app/appcountrysidetourism/list`, null, {
          params: {
            type: 4,
            ...this.search
          }
        }).then(res => {
          if (res.code == 0) {
            this.tableData = res.data.records
            this.total = res.data.total
          }
        })
      },

      changeStatus (item) {
        let title = item.status == '1' ? '是否要取消发布?' : '是否要发布?';
        this.$confirm(title, {type: 'warning'}).then(() => {
          item.status = item.status == '1' ? '0' : '1'
          this.instance.post('/app/appcountrysidetourism/addOrUpdate', item).then(res => {
            if (res && res.code == 0) {
              title == '是否要发布?' ? this.$message.success('发布成功') : this.$message.success('取消发布成功')
              this.getList()
            }
          })
        })
      },

      remove(id) {
        this.$confirm('确定删除该数据？').then(() => {
          this.instance.post(`/app/appcountrysidetourism/delete?ids=${id}`).then(res => {
            if (res.code == 0) {
              this.$message.success('删除成功！')
              this.getList()
            }
          })
        })
      },

      toAdd(id) {
        this.$emit('change', {
          type: 'Add',
          params: {
            id: id || ''
          }
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  .notice {
  }
</style>
